//
//  ViewController.swift
//  optional-chaining3
//
//  Created by yoshiyuki oshige on 2014/07/27.
//  Copyright (c) 2014年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    // Playerクラス
    class Player {
        var magic:Magic?
        //初期値の設定
        init(spell:String?){
            // spellがnilでも空白でもないとき
            if (spell != nil)&&(spell != "") {
                //Magicクラスのインスタンスを作る
                self.magic = Magic(spell:spell!)
            }
        }
    }
    
    // Magicクラス
    class Magic {
        // Stone構造体
        struct Stone {
            var color:String
            var spell:String
        }
        
        var magicPower:Int
        var magicStone:Stone
        // 初期値の設定
        init(spell:String){
            // magicPowerプロパティを設定する
            self.magicPower = count(spell)/2
            // magicStoneプロパティを設定する
            let index = Int(arc4random_uniform(3))
            let stoneColor = ["red","blue","green"][index]
            self.magicStone = Stone(color:stoneColor, spell:spell)
        }
        // magicStoneを返すメソッド
        func doMagic() -> Stone? {
            if magicPower == 0 {
                // 0のときはnilを返す
                magicPower = 3
                return nil
            } else {
                // 0でなければmagicStoneを返す
                magicPower-- // 1引く
                return self.magicStone
            }
        }
    
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        //　Playerクラスのuserを作って試す
        var user:Player = Player(spell: "puipui")
        // 5回試す
        for _ in 1...5 {
            var mp = user.magic?.magicPower as Int!
            var spell = user.magic?.doMagic()?.spell as String!
            print("パワーは\(mp),")
            println("呪文は\(spell)")
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}
