//
//  ViewController.swift
//  closure_dicMap
//
//  Created by yoshiyuki oshige on 2014/08/03.
//  Copyright (c) 2014年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    func dicMap(var dic:Dictionary<String,Int>, closure:(String,Int)->(String,Int))
        -> Dictionary<String,Int> {
            
            // 辞書からすべての要素を取り出してクロージャに渡す
            for (key, value) in dic {
                let(theKey, newValue) = closure(key, value)
                //クロージャから戻った値で辞書の値を更新する
                dic[theKey] = newValue
            }
            return dic
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let abcDic = ["a":3, "b":4, "c":9]
        //辞書の値をすべて2倍にする
        let result = dicMap(abcDic){(key:String, value:Int) -> (String,Int) in
            return (key,value*2)
        }
        println(result)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

