//
//  ViewController.swift
//  closure_map
//
//  Created by yoshiyuki oshige on 2014/08/03.
//  Copyright (c) 2014年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
                            
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let numbers = [4,7,2,9]
        //配列のすべての値を2倍にする
        let array1 = map(numbers, {(let v:Int) -> Int in
                return v*2
            })
        println(array1)
        
        //第２引数のクロージャを外に出した書式
        let array2 = map(numbers){(let v:Int) -> Int in
            return v*2
        }
        println(array2)
        
        //型推論を利用し、returnを省略した書式
        let array3 = map(numbers){v in v*2}
        println(array3)
        
        //引数を省略した書式
        let array4 = map(numbers){$0*2}
        println(array4)
        
        
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

